; do^h~
[return cond="typeof(global.ERuby) != 'undefined'"]

; rg eruby
; [eruby text=r str=rΏە] Ǝw肷邱ƂŁAr̋ϓB
;
; 2014/11/06  1.21	EsvȃfobObZ[W폜
; 2013/11/28  1.2	Ekaginvalidate邽߁AKAGPlugin
; 2012/09/05  1.11	r̔zuʒuɕύX
; 2012/09/05  1.1	r̔zuʒuύX
; 2010/07/13  1.01	tHgTCYύXɋϓU肷ƁAϓ
;			ȂĂȂ̂C

[iscript]

class ERuby extends KAGPlugin {
	var window;
	var startpos, space;	// X^[gʒuAꕶԂ̋(܂)
	var idx;		// ݂̃r\
	var ruby;		// ݏݒ̃r

	// RXgN^
	function ERuby(window)
	{
		this.window = window;
		startpos    = 0;
		space       = 0;
		idx         = 0;
		ruby        = "";
	}

	// fXgN^
	function finalize()
	{
	}

	// r𓾂
	function getRubyWidth(ruby)
	{
		var cur = window.current;
		var ll = cur.lineLayer;
		var orgsize = ll.font.height;
		ll.font.height = cur.rubySize;
		var rw = ll.font.getTextWidth(ruby);
		ll.font.height = orgsize;
		return rw;
	}

	// rX^Cݒ肷(e,l,c,r̂ǂꂩ)
	function getAlign(align='e')
	{
		if (align == 'l' || align == 'left')
			return 'l';
		if (align == 'c' || align == 'center')
			return 'c';
		if (align == 'r' || align == 'right')
			return 'r';
		if (align == 'e' || align == 'expand')
			return 'e';
		return 'e'; // ftHg eB
	}

	// r`悷OBrubyUꂽɈxĂ
	function initRuby(ruby, str, align)
	{
		idx = 0;
		this.ruby = ruby;
		align = getAlign(align);

		var cur = window.current;
		var ll = cur.lineLayer;

		var cw = ll.font.getTextWidth(str);	// ̕
		var rw = getRubyWidth(ruby);		// r̕
//dm('cw,rw = ' + cw + ', ' + rw);
		// rJnʒuƃr߂(܂Βl̂)
		startpos = (cw-rw)/2, space = 0;
		if (align == 'l')
			startpos = 0;
		else if (align == 'r')
			startpos = cw-rw;
		else if (align == 'e' && cw > rw) {
			space    = cw/ruby.length;		    //Ԋu
			//startpos = cw/ruby.length/2-cur.rubySize/2;//Jnʒu
			startpos = (cw-((ruby.length-1)*space+cur.rubySize))/2;
		}
	}

	// rꕶ
	function drawRuby(ruby, rx, ry)
	{
		var cur = window.current;
		var ll = cur.lineLayer;
		var orgsize = ll.font.height;
		ll.font.height = cur.rubySize;

		rx = int(rx+0.5), ry = int(ry+0.5);
		if (cur.edge)
			ll.drawText(rx, ry, ruby, cur.chColor, 255,
				    cur.antialiased, cur.edgeEmphasis,
				    cur.edgeColor, cur.edgeExtent, 0, 0);
		else if (cur.shadow)
			ll.drawText(rx, ry, ruby, cur.chColor, 255,
				    cur.antialiased, 255, cur.shadowColor,
				    0, cur.shadowOffsetX, cur.shadowOffsetY);
		else
			ll.drawText(rx, ry, ruby, cur.chColor, 255,
				    cur.antialiased);
		ll.font.height = orgsize;
	}

	// ꕶ\ɌĂԁB̕ɑΉ郋r\
	// sKAGɏ邽߂ɁAkag.current.processCh()͌Ă΂Ȃ
	// [emb]ňꕶ\ɂ̊֐ĂԂƁB
	function drawRuby_forOneText(str, stridx)
	{
		var cur = window.current;
		var ll = cur.lineLayer;
		var cw = ll.font.getTextWidth(str[stridx]); // O̕̕
		var dx, dy;

		// dx/dy  ÕLN^\ʒu߂
		if (cur.vertical) {
			// c̏ꍇ
                        dx = cur.lineLayerBase+(cur.fontSize>>1);
			dy = cur.lineLayerPos - cw;
		} else {
			// ̏ꍇ
                        dx = cur.lineLayerPos - cw;
			dy = cur.lineLayerBase-cur.fontSize;
		}
		// O܂ł̕
		var lw = ll.font.getTextWidth(str.substr(0,stridx));

		// ɑΉ郋rU
		for (; idx < ruby.length; idx++) {
			var rx, ry, rp = startpos;
			if (space == 0)
				rp += getRubyWidth(ruby.substr(0,idx));
			else
				rp += space*idx;
			if (rp > ll.font.getTextWidth(str.substr(0,stridx+1)))
				// ̕ɑΉ郋r
				if (stridx < str.length-1)
					return;
				// AŌ̏ꍇ͂͂ݏor
				// \邽ߖ
			if (cur.vertical) {
				// c
				rx = dx + cur.rubySize + cur.rubyOffset;
				ry = dy+rp-lw;
			} else {
				// 
				rx = dx+rp-lw;
				ry = dy - cur.rubySize - cur.rubyOffset;
			}
			drawRuby(ruby[idx], rx, ry);
		}
	}
}


// 
kag.addPlugin(global.eruby = new global.ERuby(kag));

[endscript]


[macro name="eruby"]
[if exp="mp.str === void"]
	[ruby *]
[else]
;	[eval exp="global.eruby.initRuby(mp.text, mp.str, mp.align)"]
; eruby_loopֈړ
	[eval exp="mp.idx = 0"]
	[call storage=eruby.ks target=*eruby_loop]
[endif]
[endmacro]



[return]


*eruby_loop
; \ȂȂI
[return cond="mp.idx >= mp.str.length"]
; ꕶ\B
[emb exp="mp.str[mp.idx]"]
;  [emb] ɂĕƂwait邱Ƃ
[if exp="mp.idx == 0"]
	; ̑傫ς́Akag.current.fontSize Ɏۂ̃tHg
	; TCYfĂȂƂ̂ŁcBkag.current._fontSize
	; QƂƁÅgŎςႤȂ̂ł
	; Ώœ
	[eval exp="global.eruby.initRuby(mp.text, mp.str, mp.align)"]
[endif]
; āAł̕ɑΉ郋rUBwaitƕsRɌ邩
; ȂAʓ|ȂƂɉsɑΉ邽߂ɂĂBāB
[eval exp="global.eruby.drawRuby_forOneText(mp.str, mp.idx++)"]

; Ƃ̓[vցB
[jump target=*eruby_loop]















; ꂪ肽Ȃuʓ|ȉsvBMessageWindow.tjs 
; processCh() ɏĂ̂ƓB

		if ((vert ?
			cur.y >= cur.relineypos :
			cur.x >= cur.relinexpos) && cur.autoReturn) {
			if (((cur.lastDrawnCh == "" ||
			      cur.wwLeading.indexOf(cur.lastDrawnCh) == -1) &&
			     cur.wwFollowing.indexOf(ch) == -1) ||
			    (cur.lastDrawnCh != "" &&
			     cur.wwFollowingWeak.indexOf(cur.lastDrawnCh)!=-1&&
			      cur.wwFollowingWeak.indexOf(ch) != -1)) {
				// Ōɕ`悵̂s֑łȂꍇ
				// ꂩ`悷̂s֑łȂ
				// ꍇ
				// ܂͎֑AĂȂꍇ
                                cur.reline();
			}
			elsif (vert ? y > cur.imageHeight : x > cur.imageWidth)
			{
				// ꂩ`悷֑̂ł͂ȂāA
				// m E[zꍇ
				// ( ̏ꍇ͗]͍lȂ )
				cur.reline();
			}
		}


