; do^h~
[return cond="typeof(global.Interpolation) != 'undefined'"]

[iscript]

// ԗpGg(Βl̂݁El0Jn)
class RelInterpolationElement
{
	var vals;		// nbVz((relval,reltick,accel), ...)

	// RXgN^
	function InterpolationElement()
	{
		// 擪͌vZp̃_~[Ƃ^[~l[^
		vals = [ %[relval:0, reltick:0, accel:0] ];
	}

	// fXgN^
	function finalize()
	{
//		invalidate vals;
	}

	function addPath(relval, tick, accel)
	{
		var pre = vals[vals.count-1];

		// relvaĺAɓn鎞ɂ͑ΒlɂȂĂ
		tick  = (tick  != "") ? tick  : pre.reltick
						- vals[vals.count-2].reltick;
		accel = (accel != "") ? accel : pre.accel;

		vals.add( %[
			relval:real(relval),
			reltick:(pre.reltick + real(tick)),
			accel:real(accel)
		] );
	}

	function clearPath()
	{
		vals.count = 1;	// ŏ̈cč폜
	}

	// reltick\ȎԂ(start/end͈̔͂Ɏ܂Ă邩)
	function isValidRelTick(reltick)
	{
		var lastreltick = vals[vals.count-1].reltick;
		return(0 <= reltick && reltick <= lastreltick);
	}

	function getLastRelVal()
	{
		return(vals[vals.count-1].relval);
	}

	function getLastRelTick()
	{
		return(vals[vals.count-1].reltick);
	}

	function getCurrentIdx(reltick)
	{
		if(reltick < 0)
			return(0);			// قɔ͈͊O
		var idx;
		for(idx = 1; idx < vals.count; idx++)	// K{(1ɒ)
			if(reltick <= vals[idx].reltick)
				return(idx);
		return(vals.count-1);			// 傫قɔ͈͊O
	}

	function getCurrentRelVal(reltick)
	{
		var idx      = getCurrentIdx(reltick);
		if(idx == 0)	// Œl̏ꍇidx0ɂȂ
			return 0;
		var cur	     = vals[idx];
		var difftick = cur.reltick - vals[idx-1].reltick;
		var diffval  = cur.relval  - vals[idx-1].relval;
		var per      = (reltick - vals[idx-1].reltick)/difftick;
		// per = p[Zg, 0`1.0
		if(cur.accel > 1)		// (ŏxXɑ)
			per = Math.pow(per, cur.accel);
		else if(cur.accel < -1) {	// ㌷(ŏXɒx)
			per = 1.0 - per;
			per = Math.pow(per, -cur.accel);
			per = 1.0 - per;
		}
		return(per*diffval + vals[idx-1].relval);
	}

	// Rs[
	function assign(src)
	{
		vals.assignStruct(src.vals);
	}

	// Z[uɏォĂ΂
	function store()
	{
		var dic = %[];
		dic.vals = [];
		dic.vals.assignStruct(vals);
		return(dic);
	}

	// [hɏォĂ΂
	function restore(dic)
	{
		if(dic === void)
			return;
		vals.assignStruct(dic.vals);
	}

}



// ԗpGg(Βl̂݁El0JnE[v)
class RelLoopInterpolationElement extends RelInterpolationElement
{
	var loop = 1;		// loop count(0Ŗ[v)

	function RelLoopInterpolationElement(path=void, loop=1)
	{
		super.InterpolationElement();
		this.setRelValues(path, loop);
	}

	// fXgN^
	function finalize()
	{
		super.finalize();
	}

	// lݒ肷Bpath̗́A(l,v(ms),x)gB
	function setRelValues(path=void, loop=1)
	{
		this.loop = loop;
		if(path === void)
			return;
		clearPath();
		var preval = "0";
		var a = path.split( "()," );	// ӁI5̔{łȂƗ
		for(var i = 0; i < a.count; i += 5) {	// łȂƃ_
			var val = (a[i+1] != "") ? a[i+1] : preval;
			preval = val;
			if(val[0] == 'r')	// val!=""͕ۏ؂Ă
				val = real(val.substr(1))+super.getLastRelVal();
			else
				val = real(val);
			addPath(val, a[i+2], a[i+3]);
		}
	}

	// loop̊ȌpɁB
	function setLoop(loop = 1)
	{
		this.loop = loop;
	}

	// ŌRelTick𓾂
	function getLastRelTick()
	{
		if(loop == 0)
			return +Infinity;
		return(loop*super.getLastRelTick());
	}

	// ŌRelVal𓾂
	function getLastRelVal()
	{
		return(loop*super.getLastRelVal());
	}

	// reltickɑ΂郋[vJEg(0`)ԂB͈͊OȂ-1B
	function getRelLoopCount(reltick)
	{
		if (!isValidRelTick(reltick))
			return -1;
		if (reltick == 0)
			return 0;
		return int((reltick-1)/super.getLastRelTick()); // -1Ƀ`EC
	}

	// current(݂̈ʒu)𓾂
	function getCurrentRelVal(reltick)
	{
		if(reltick < 0)				// ͈͂菬
			return(0);
		if(getLastRelTick() < reltick)		// ͈͊O(fJ)
			return(getLastRelVal());

		var lp = getRelLoopCount(reltick);
		var val = super.getCurrentRelVal(reltick
						 - lp*super.getLastRelTick());
		val += lp*super.getLastRelVal();
		return( val );
	}

	// reltick\ȎԂ(start/end͈̔͂Ɏ܂Ă邩)
	function isValidRelTick(reltick)
	{
		var lastreltick = getLastRelTick();
		return(0 <= reltick && reltick <= lastreltick);
	}

	// I܂łɂ鎞ԂԂ(߂Ăꍇ-̒l)
	function toFinishRelTick(reltick)
	{
		var ret = getLastRelTick() - reltick;
		return(ret);
	}

	// Rs[
	function assign(src)
	{
		super.assign(src);
		loop = src.loop;
	}

	// Z[uɏォĂ΂
	function store()
	{
		var dic = super.store();
		dic.loop = loop;
		return(dic);
	}

	// [hɏォĂ΂
	function restore(dic)
	{
		if(dic === void)
			return;
		super.restore(dic);
		loop		= dic.loop;
	}
}



// ԗpGg(Βl)
class Interpolation extends RelLoopInterpolationElement
{
	var initval;		// lBxݒ肳ꂽύXȂB
	var inittick;		// JnԁBpauseȂύXȂ

	function Interpolation(val=0, tick=System.getTickCount(), path=void, loop=1)
	{
		super.RelLoopInterpolationElement(path, loop);
		initval = val;
		inittick = tick;
	}

	// fXgN^
	function finalize()
	{
		super.finalize();
	}

	// lݒ肷Bpath̗́A(l,v(ms),x)gB
	function setValues(val=0, tick=System.getTickCount(), path=void, loop=1)
 	{
 		super.setRelValues(path, loop);
		initval = val;
		inittick = tick;
	}

	// ݂(Jn)Ԃݒ肷this.initx = initx;
	function setInitVal(val)
	{
		initval = val;
	}
	// ݂(Jn)Ԃݒ肷this.initx = initx;
	function setInitTick(tick=System.getTimeCount())
	{
		inittick = tick;
	}

	// current(݂̈ʒu)𓾂
	function getCurrentValue(tick=System.getTickCount())
	{
		return(initval + super.getCurrentRelVal(tick-inittick));
	}

	// last(ŏÏʒu)𓾂
	function getLastValue()
	{
		return(initval + super.getLastRelVal());
	}

	// last(ŏI̎)𓾂
	function getLastTick()
	{
		return(initval + super.getLastRelTick());
	}

	// tick\ȎԂ(start/end͈̔͂Ɏ܂Ă邩)
	function isValidTick(tick=System.getTickCount())
	{
		return isValidRelTick(tick - inittick);
	}

	// I܂łɂ鎞ԂԂ
	function toFinishTick(tick=System.getTimeCount())
	{
		return(toFinishRelTick(tick - inittick));
	}

	// Rs[
	function assign(src)
	{
		initval		= src.initval;
		inittick	= src.inittick;
		super.assign(src);
	}

	// Z[uɏォĂ΂
	function store(curtick = System.getTickCount())
	{
		var dic = super.store();
		dic.initval	= initval;
		dic.idxtick	= curtick - inittick;
		return(dic);
	}

	// [hɏォĂ΂
	function restore(dic, curtick = System.getTickCount())
	{
		if(dic === void)
			return;
		super.restore(dic);
		initval		= dic.initval;
		inittick	= curtick - dic.idxtick;
	}
}


[endscript]

[return]
